# Getting Started

This section walks you through the basics of MonoGame, and helps you to create your first game.

First, select the operating system and toolset you will be working with to create your first MonoGame project, then continue reading to understand the basic layout of a MonoGame project.

By the end of this tutorial set, you will have a working project to build for your target platform and will be ready to tackle your next steps.

## 1. Setting up your development environment

- [Windows](1_setting_up_your_development_environment_windows.md)
- [macOS](1_setting_up_your_development_environment_macos.md)
- [Linux](1_setting_up_your_development_environment_ubuntu.md)

## 2. Creating a new project

- With [Visual Studio 2022](2_creating_a_new_project_vs.md)
- With [Visual Studio 2022 for Mac](2_creating_a_new_project_vsm.md)
- With [the .NET command line interface](2_creating_a_new_project_netcore.md) (compatible with JetBrains Rider and Visual Studio Code)

## 3. Building your game

- [Understanding the Code](3_understanding_the_code.md)
- [Adding Content](4_adding_content.md)
- [Adding Basic Code](5_adding_basic_code.md)
