# Tutorials

Check out the awesome work of the larger MonoGame community with their own tutorials, blogs and videos.

> If you have a blog or article on MonoGame and wish to have it recognized here, reach out to the MonoGame team using the [support links listed on the help page](help_and_support.md).

## Microsoft

- [Archived XNA Game Studio documentation](https://docs.microsoft.com/en-us/previous-versions/windows/xna/bb200104(v=xnagamestudio.41))
- [XNA Game Studio educational resources archive](https://github.com/SimonDarksideJ/XNAGameStudio)

## RB Whitaker's MonoGame Tutorials

- [1 - C# Crash Course](http://rbwhitaker.wikidot.com/c-sharp-tutorials)
- [2 - MonoGame Getting started tutorials](http://rbwhitaker.wikidot.com/monogame-getting-started-tutorials)
- [3 - MonoGame 2D tutorials](http://rbwhitaker.wikidot.com/monogame-2d-tutorials)
- [4 - 3D tutorials](http://rbwhitaker.wikidot.com/monogame-3d-tutorials)
- [Extra - XNA tutorials](http://rbwhitaker.wikidot.com/xna-tutorials)

## Neil Danson's F# series

- [Part 1 - MacOS](http://neildanson.wordpress.com/2013/07/30/f-and-monogame/)
- [Part 2 - Android](http://neildanson.wordpress.com/2013/07/31/f-and-monogame-part-2-android/)
- [Part 3 - iOS](http://neildanson.wordpress.com/2013/07/31/f-and-monogame-part-3-ios/)
- [Part 4 - Content Pipeline](http://neildanson.wordpress.com/2013/08/13/f-and-monogame-part-4-content-pipeline/)

## Darkside of MonoGame video series

- [Getting Started with MonoGame using Visual Studio 2019](https://www.youtube.com/watch?v=BahlvXQcJw4)
- [Getting Started with MonoGame using Visual Studio for Mac](https://www.youtube.com/watch?v=Hxo9A0-qcVo)
- [Getting Started with MonoGame using the command-line](https://www.youtube.com/watch?v=MOcZriFLt7c)
- [Walk-through setting up your Mac for MonoGame CLI](https://www.youtube.com/watch?v=2c_41vMhDYo)
- [Getting Started with MonoGame using 2D](https://www.youtube.com/watch?v=6inkDfpUxAU)
- [Getting Started with MonoGame using XML](https://www.youtube.com/watch?v=wCc_rLrqsIo)
- [Getting the most out of your assets–The MonoGame Content Pipeline](https://www.youtube.com/watch?v=5mEQqCgTaLU)
- [MonoGame - Building multi-platform solutions](https://www.youtube.com/watch?v=WonVmlpPBuU&t=735s)
- [Building apps & games for Xbox One using UWP](https://www.youtube.com/watch?v=AAMToCwPy8s&t=1s)

## Video Tutorials

- [CodingMadeEasy RPG Tutorial](http://www.youtube.com/watch?feature=player_embedded&v=agt9-J9RPZ0)
- [Psuedo Games Tutorials](http://www.youtube.com/watch?feature=player_embedded&v=BwtQn02oy6A)
- [Desenvolvendo jogos multiplataforma em C# com MonoGame - Alexandre Chohfi (Portuguese)](http://channel9.msdn.com/Blogs/MSDN-Brasil-Cursos-de-Desenvolvimento/Desenvolvendo-jogos-multiplataforma-em-C-com-MonoGame)
- [Desenvolvimento de jogos para Windows 8 com XNA - Alexandre Chohfi (Portuguese)](https://www.youtube.com/watch?v=gM5pRnYV1tA)
- [Batholith Entertainment Game dev tutorials](https://www.youtube.com/playlist?list=PLZ6ofHM1rvK8lQSoKX1USZstM-ZXikFHp)
- [Let's Code: The T-Rex Runner Game with MonoGame](https://www.youtube.com/watch?v=DJCQVJ83J1U)

## Others

- [Dark Genesis Blog MonoGame content](http://darkgenesis.zenithmoon.com/tag/monogame/)
- [awesome-monogame - A large list of MonoGame libraries and more by aloisdeniel](https://github.com/aloisdeniel/awesome-monogame)
- [A collection of tutorials, libraries and more, many of which are MonoGame related](https://github.com/UnterrainerInformatik/GameDevelopmentLinks)
- [How to create animations and sprite sheets for MonoGame](https://www.codeandweb.com/texturepacker/tutorials/how-to-create-sprite-sheets-and-animations-with-monogame)
- [Making a platformer in F# with MonoGame](http://bruinbrown.wordpress.com/2013/10/06/making-a-platformer-in-f-with-monogame/)
- [XNA 4.0 Shader Programming / HLSL](http://digitalerr0r.wordpress.com/tutorials/)
- [Using Spine with MonoGame - by Randolph Burt (Randeroo)](http://randolphburt.co.uk/2013/03/30/dragons-and-dancing-crabs/)
- [Mac porting series](http://benkane.wordpress.com/2012/01/20/the-great-porting-adventure-day-8/)
- [Porting a Windows Phone 7 Game to Android](http://warrenburch.blogspot.co.uk/2011/12/porting-windows-phone-7-game-to-android.html)
- [A series on embedding MonoGame/WinGL into WinForms](http://jaquadro.com/2013/03/bringing-your-xna-winforms-controls-to-monogame-opengl/)
- [French articles about MonoGame on Linux, Windows and Windows 8](http://www.demonixis.net/blog/category/tutoriels/tuto-xna/)
- [MonoGame "Hello World" on Mac OS X and Xamarin Studio](http://jaquadro.com/2013/09/monogame-hello-world-on-mac-os-x-and-xamarin-studio/)
- [Solving Resolution Independent Rendering And 2D Camera Using Monogame](http://blog.roboblob.com/2013/07/27/solving-resolution-independent-rendering-and-2d-camera-using-monogame/)
- [XNA is Dead; Long Live the New XNA, MonoGame](http://www.codemag.com/Article/1411081)
- [Running MonoGame on Android Wear](http://crossplatform.io/running-monogame-on-android-wear/)
- [Text rendering in MonoGame](https://roy-t.nl/2018/07/04/Text-Rendering.html)
- [Randomchaos-MonoGame-Samples](https://github.com/NemoKradXNA/Randomchaos-MonoGame-Samples)
