---
uid: index.md
title: Introduction
---

<p align="center">
<br/>
  <img src="https://raw.githubusercontent.com/Mono-Game/MonoGame.Logo/master/FullColorOnLight/HorizontalLogo_128px.png"/>
<br/>
<br/>
</p>

Welcome to the MonoGame documentation hub!

MonoGame is a simple and powerful .NET framework for creating games for desktop PCs, video game consoles, and mobile devices using the C# programming language. It has been succesfully used to create games such as [Streets of Rage 4](https://store.steampowered.com/app/985890/Streets_of_Rage_4/), [Carrion](https://store.steampowered.com/app/953490/CARRION/), [Celeste](https://store.steampowered.com/app/504230/Celeste/), [Stardew Valley](https://store.steampowered.com/app/413150/Stardew_Valley/), and [many other](https://www.monogame.net/showcase/).

It is a re-implementation of the discontinued [Microsoft's XNA Framework](https://msdn.microsoft.com/en-us/library/bb200104.aspx), and it provides the following features:

- Game framework
- 2D and 3D rendering
- Sound effect and music playback
- Keyboard, mouse, touch, and controller inputs
- Content building and optimization
- Math library optimized for games

This documentation [helps you to get started](articles/getting_started/0_getting_started.md) by providing overviews of key features and tools, and a complete API reference.

Please use the links at the top and left to navigate the documentation sections.

> This documentation assume that the reader has a basic knowledge of the C# programming language.

## What is MonoGame exactly?

MonoGame is a "bring your own tools" kind of framework, which means that it provides the building blocks to build your own engine and tools, but it isn't quite an engine itself.

If you are expecting a scene editor (like Unity or Unreal), MonoGame is not that.

If you love coding and understanding how things work under the hood, MonoGame might be what you are looking for. And fear not, getting a game running with MonoGame only takes a few minutes.

[Let's get started!](articles/getting_started/0_getting_started.md)

## We Need Your Help!

MonoGame is an open-source project maintained by its community. Great open source projects require high-quality documentation. This is a call for volunteers to continue to help us make the MonoGame documentation truly great. If you can create tutorials, feature guides, code snippets, reference docs, video walkthroughs, or make any improvement to the current documentation, we could use your help!

Check out the [README on GitHub](https://github.com/MonoGame/MonoGame/blob/develop/README.md) or [talk with us on the community site](http://community.monogame.net/t/lets-improve-the-monogame-documentation/916) to learn how to help! For a quick start, you can jump on this [list of documentation tasks](https://github.com/MonoGame/MonoGame/projects/4).
